<?xml version="1.0" encoding="utf-8" ?>
<xsl:stylesheet version="1.0" 
xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<!--
EDUGRAF - Laboratório de Software Educacional
INE - Departamento de Informática e Estatística
UFSC - Universidade Federal de Santa Catarina

Projeto Dix
Documentação de componentes Dix
Criado em 24/03/2004
-->

<xsl:output
method="xml"
version="1.0"
encoding="UTF-8"
indent="yes"
/>
<xsl:template match="/">

<html>

	<head>
		<meta http-equiv="Content-Type" content="text/html;charset=utf-8" />
		<title>.:: dix ::. </title>
		<link rel="stylesheet" type="text/css" href="css/componentes.css"></link>
		<link rel="stylesheet" type="text/css" href="css/estilo.css"></link>
	</head>

	<body>
		<a  name="indice"><h1>Componentes de IGU</h1></a>
		
		<h3><a href=" #áreaDeTexto">Área de texto</a></h3>
		<h3><a href=" #áreaSensível">Área Sensível</a></h3>
		<h3><a href=" #botão">Botão</a></h3>
		<h3><a href=" #botõesDeRádio">Botões de Rádio</a></h3>
		<h3><a href=" #caixaDeEscolha">Caixa de Escolha</a></h3>
		<h3><a href=" #campoDeTexto">Campo de Texto</a></h3>
		<h3><a href=" #etiqueta">Etiqueta</a></h3>
		<h3><a href=" #grade">Grade</a></h3>
		<h3><a href=" #imagem">Imagem</a></h3>
		<h3><a href=" #listaDeEscolha">Lista de Escolha</a></h3>
		<br></br>
		
		<xsl:apply-templates select="document('componentes.xml')/componentes/componente"/>
	</body>

</html>

</xsl:template>

<xsl:template match="componente">
	<xsl:variable name="componente" select="." />
	<xsl:apply-templates select="document(concat($componente, '.xml'))/elemento"/>
</xsl:template>

<xsl:template match="elemento">

			<h2>
			<a class="elemento" name="{@nome}">
			   <xsl:value-of select="@nome"/>
			</a>
			</h2>
			
			<h4><a href=" #indice">Voltar para o Índice</a></h4>
			
			<dl>

				<xsl:if test='descrição'>
					<dt>Descrição</dt>
					<dd><xsl:value-of select="descrição"/></dd>
				</xsl:if>

				<dt>Atributos</dt>
				<dd>
					<xsl:if test="@éUm = 'componente'">
						<xsl:apply-templates select="document('componente.xml')/componente/atributos/atributo">
							<xsl:with-param name="componente" select="@nome"/>
						</xsl:apply-templates>
					</xsl:if>
					<xsl:apply-templates select="atributos/atributo">
						<xsl:with-param name="componente" select="@nome"/>
					</xsl:apply-templates>	
				</dd>

				<xsl:if test='valor'>
					<dt><a>
						<xsl:attribute name="name"><xsl:value-of select="@nome" />.valor</xsl:attribute>
						<xsl:attribute name="href">#<xsl:value-of select="@nome" />.valor</xsl:attribute>
						Valor
					</a></dt>
					<dd>
					   <xsl:choose>
      					<xsl:when test="valor/elementoFilho">
         				   <xsl:apply-templates select="valor/elementoFilho"/>
            			</xsl:when>
            			<xsl:otherwise>
                  		<xsl:value-of select="valor"/>
               		</xsl:otherwise>
            		</xsl:choose>
					</dd>
				</xsl:if>
				
				<xsl:if test='eventos'>
					<a name="{@nome}.estimulos"/>
					<dt>Tipos de Estímulos Suportados</dt>
					<dd><xsl:text disable-output-escaping="yes">	</xsl:text>
			        <xsl:for-each select="eventos/evento">
						<a href = "estimulos.xml#{.}">
							<xsl:value-of select="." />
							<xsl:text disable-output-escaping="yes">  </xsl:text>
						</a>
			        </xsl:for-each>				
					</dd>
				</xsl:if>

				<xsl:if test='exemplos'>
					<a name="{@nome}.exemplos"><xsl:text> </xsl:text></a>
					<dt>Exemplos</dt>
					<dd>
				 		<xsl:for-each select="exemplos/exemplo">
                     <pre><code><xsl:value-of select="código" /></code></pre>
							<a href="{uri}" target="_blank">Clique aqui para visualizar o exemplo</a>
						</xsl:for-each>
					</dd>
				</xsl:if>

			</dl>

</xsl:template>

<xsl:template match="elementoFilho">
   
   <b>Elemento Filho: <xsl:value-of select="@nome"/></b> 
   <dd>
      		<xsl:if test='descrição'>
					<dt class="subLista">Descrição</dt>
					<dd><xsl:value-of select="descrição"/></dd>
				</xsl:if>
				
				<dt class="subLista">Atributos</dt>
				<dd>
					<xsl:apply-templates select="atributos/atributo">
						<xsl:with-param name="componente"><xsl:value-of select="../../@nome" />.valor</xsl:with-param>
					</xsl:apply-templates>
				</dd>
				
				<xsl:if test='valor'>
					<dt class="subLista">
						<a name="{../../@nome}.valor.valor"><xsl:text> </xsl:text></a>
						Valor
					</dt>						
					<dd><xsl:value-of select="valor"/></dd>
				</xsl:if>

	</dd>
   
</xsl:template>

<xsl:template match="atributos/atributo">
	<xsl:param name="componente" />
	<xsl:call-template name="atributos">
		<xsl:with-param name="componente" select="$componente"/>
	</xsl:call-template>
</xsl:template>

<xsl:template name="atributos">
<xsl:param name="componente" />
	<dt class="subLista">	
	<a name="{$componente}.{@nome}"><xsl:text> </xsl:text></a>
	<xsl:value-of select="@nome" /><br/></dt>
	<dd class="subLista">
		<xsl:if test="descrição"><b>Descrição: </b> <xsl:value-of select="descrição" /><br/></xsl:if>
		<xsl:if test="@tipo"><b>Tipo: </b> <xsl:value-of select="@tipo" /><br/></xsl:if>
		<xsl:if test="@préDefinido"><b>Valor pré definido: </b> <xsl:value-of select="@préDefinido" /></xsl:if>
	</dd>
</xsl:template>

</xsl:stylesheet>