﻿<?xml version="1.0" encoding="utf-8" ?>
<xsl:stylesheet version="1.0" 
xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<!--
Universidade Federal de Santa Catarina
Centro Tecnológico - Departamento de Informática e Estatística
Laboratório de Software Educacional - EDUGRAF

Projeto Telis
Documentação de descrição das primitivas Telis
Criado em 26/08/2003
-->
 <xsl:output
 	method="html"
 	doctype-public="-//W3C//DTD XHTML 1.0 Strict//EN"
 	doctype-system="http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"
 	omit-xml-declaration="yes"
 	indent="no"
 	encoding="UTF-8" />
<xsl:template match="/">

  <html>

  <head>
    <link rel="stylesheet" type="text/css" href="../css/primitivas.css" />
    <link rel="stylesheet" type="text/css" href="../css/estilo.css" />
  </head>

  <body>
  	<h1>Relação dos estímulos Dix</h1>
  	Os estímulos aqui listados são aqueles emitidos pelos componentes Dix.
    <xsl:for-each select="estímulos/estímulo">
    <!--<xsl:sort select="@nome"/>-->
    <h2>
    <a>
      <xsl:attribute name="name">
        <xsl:value-of select="@nome"/>
      </xsl:attribute>
      <xsl:value-of select="@nome"/>
    </a>
    </h2>
      <dl>
        <dt>Descrição:</dt>
        <dd><xsl:value-of select="descrição"/></dd>
        <dt>Filtro:</dt>
        <dd><xsl:value-of select="filtro"/></dd>
        <dt>Componentes que emitem esse estímulo:</dt>
        <xsl:for-each select="componentes/componente">
        	<dd><li><xsl:value-of select="@nome"/></li></dd>
        </xsl:for-each>
        <dt>Exemplo:</dt>
        <dd><xsl:value-of select="exemplo"/></dd>
      </dl>
    </xsl:for-each>

	<pre>
	
	
	</pre>
	<h4>Modificadores</h4>
	Os modificadores são as teclas 
	<xsl:for-each select="estímulos/modificadores/tecla">
		<xsl:if test="not(position() = 1)">, </xsl:if>
		<xsl:value-of select="." />
	</xsl:for-each>. Os códigos dos modificadores são expostos abaixo:

	<xsl:for-each select="estímulos/modificadores/tecla">
	<xsl:sort select="@código" />
			<dd><li><xsl:value-of select="."/>: <xsl:value-of select="@código"/></li></dd>
	</xsl:for-each>

	<xsl:value-of select="estímulos/modificadores/observação"/>

  </body>

  </html>

</xsl:template>
</xsl:stylesheet>