package atributoHabilitado;

import edugraf.jadix.ApliqueSemPichador;
import edugraf.jadix.eventos.EventoSimples;
import edugraf.jadix.eventos.nomes.NomeDeEventosSimples;
import edugraf.jadix.fachada.ComponenteDix;
import edugraf.jadix.fachada.TratadorDixAbstrato;

 public class ApliqueAtributoHabilitado extends ApliqueSemPichador {
	
	private ComponenteDix caixaDeTexto = this.obterPaginaDix().criarProcuradorDeComponente("caixaDeTexto");
	private ComponenteDix BotaoHabilitar = this.obterPaginaDix().criarProcuradorDeComponente("habilitar");
	private ComponenteDix botaoDesabilitar = this.obterPaginaDix().criarProcuradorDeComponente("desabilitar");
	private ComponenteDix mostrador = this.obterPaginaDix().criarProcuradorDeComponente("mostrador");
		
	public void iniciar(){
		TratadorComponenteHabilitado tratadorBotaoHabilitar = new TratadorComponenteHabilitado();
		TratadorComponenteDesabilitado tratadorBotaoDesabilitar = new TratadorComponenteDesabilitado();
	
		BotaoHabilitar.adicionarTratadorDeEventos(tratadorBotaoHabilitar);
		botaoDesabilitar.adicionarTratadorDeEventos(tratadorBotaoDesabilitar);
	}	
	
	class TratadorComponenteDesabilitado extends TratadorDixAbstrato{
		
		public void seDito(EventoSimples evento){
			if(evento.obterNomeDoEvento().equals(NomeDeEventosSimples.CLICADO)){
				caixaDeTexto.desabilitar();
				mostrador.fixarTexto("Caixa de texto desabilitada");
			}
		}
	}
	
	class TratadorComponenteHabilitado extends TratadorDixAbstrato{
		
		public void seDito(EventoSimples evento){	
			if(evento.obterNomeDoEvento().equals(NomeDeEventosSimples.CLICADO)){
				caixaDeTexto.habilitar();
				mostrador.fixarTexto("Caixa de texto habilitada");
			}
		}
	}
}
