package atributoVisivel;

import edugraf.jadix.ApliqueSemPichador;
import edugraf.jadix.eventos.EventoSimples;
import edugraf.jadix.eventos.nomes.NomeDeEventosSimples;
import edugraf.jadix.fachada.ComponenteDix;
import edugraf.jadix.fachada.TratadorDixAbstrato;

public class ApliqueAtributoVisivel extends ApliqueSemPichador {
	
	private ComponenteDix imagem = this.obterPaginaDix().criarProcuradorDeComponente("imagem");
	private ComponenteDix botaoTornarImagemVisivel = this.obterPaginaDix().criarProcuradorDeComponente("botaoTornarImagemVisivel");
	private ComponenteDix botaoTornarImagemInvisivel = this.obterPaginaDix().criarProcuradorDeComponente("botaoTornarImagemInvisivel");
	
	public void iniciar(){
		TratadorTornarImagemVisivel tratadorBotaoTornarVisivel = new TratadorTornarImagemVisivel();
		TratadorTornarImagemInvisivel tratadorBotaoTornarInvisivel =  new TratadorTornarImagemInvisivel();
		
		botaoTornarImagemVisivel.adicionarTratadorDeEventos(tratadorBotaoTornarVisivel);
		botaoTornarImagemInvisivel.adicionarTratadorDeEventos(tratadorBotaoTornarInvisivel);
	}	
	
	
	 class TratadorTornarImagemVisivel extends TratadorDixAbstrato{
		 
		 public void seDito(EventoSimples evento)
			{
				if(evento.obterNomeDoEvento().equals(NomeDeEventosSimples.CLICADO)){
					imagem.tornarVisivel();
				}
			}
	 }
	 
	 class TratadorTornarImagemInvisivel extends TratadorDixAbstrato{
		 
		 public void seDito(EventoSimples evento)
			{
				if(evento.obterNomeDoEvento().equals(NomeDeEventosSimples.CLICADO)){
					imagem.tornarInvisivel();
				}
			}
	 }
}
