package batePapo.jadix.modelo;

import edugraf.jadix.fachada.GerenteDeRede;

public class FachadaModelo {
	private EnviadorDeMensagem _enviador;
	private final GerenteDeRede _gerenteDeRede;
	private final MediadorBatePapo _mediador;

	public FachadaModelo(MediadorBatePapo mediador, GerenteDeRede gerenteDeRede) {
		_mediador = mediador;
		_gerenteDeRede = gerenteDeRede;
	}
	
	public FachadaModelo(GerenteDeRede gerenteDeRede) {
		_mediador = null;
		_gerenteDeRede = gerenteDeRede;
	}

	public void enviarMensagem(String mensagem) {
		_enviador.enviarMensagem(mensagem);
	}

	public String obterApelido() {
		return _enviador.obterApelido();
	}

	public void entrarNoBatePapo(String apelido) {
		_enviador = new EnviadorDeMensagem(this._gerenteDeRede, apelido);
		new ReceptorDeMensagens(this, this._gerenteDeRede);
	}

	public void mensagemRecebida(String apelidoDeQuemEnviou, String mensagem) {
		_mediador.mensagemRecebida(apelidoDeQuemEnviou, mensagem);
	}

}
