package batePapo.jadix.modelo;

import java.util.List;

import edugraf.jadix.ApliqueSemPichador;
import edugraf.jadix.fachada.PaginaDix;
import edugraf.jadix.fachada.TratadorDeEventos;
import edugraf.jadix.tiposPrimitivos.Palavra;

public class MediadorBatePapoJadix extends ApliqueSemPichador implements MediadorBatePapo {
	
	private PaginaDix página;
	
	private FachadaModelo modelo;
		
	@Override
	public void iniciar() {
		página = this.obterPaginaDix();
		modelo = new FachadaModelo(this, this.obterGerenteDeRede());
		instalarTratadores();
	}
	
	private void instalarTratadores() {
		página.instalarTratador("\"modelo\" \"batePapo\" \"entrarNoBatePapo\" texto", new TratadorEntrarNoBatePapo());
		página.instalarTratador("\"modelo\" \"batePapo\" \"enviarMensagem\" texto", new TratadorEnviarMensagem());
	}
	
	private class TratadorEnviarMensagem implements TratadorDeEventos {

		public void seDito(List<Palavra> evento) {
			usuárioDesejaEnviarMensagem(evento.get(3).comoTexto());
		}
	}
	
	
	private class TratadorEntrarNoBatePapo implements TratadorDeEventos {

		public void seDito(List<Palavra> evento) {
			String apelido = evento.get(3).comoTexto();
			usuárioDesejaEntrarNoBatePapo(apelido);			
		}
		
	}
	
	private void usuárioDesejaEntrarNoBatePapo(String apelido) {
		if (éTextoNãoNulo(apelido)) {
			modelo.entrarNoBatePapo(apelido);
			mensagemRecebida(modelo.obterApelido(), "Entrou no bate papo");
			modelo.enviarMensagem("Entrou no bate papo");
		}
	}

	private void usuárioDesejaEnviarMensagem(String mensagem) {
		if (éTextoNãoNulo(mensagem)) {
			modelo.enviarMensagem(mensagem);
			mensagemRecebida(modelo.obterApelido(), mensagem);
		}
	}
	
	private boolean éTextoNãoNulo(String texto) {
		return texto.trim().length() > 0;
	}
	
	public void mensagemRecebida(String apelido, String mensagem) {
		mensagem = apelido + ": " + mensagem;
		página.fixarParametro(mensagem).dizer("\"controle\" \"batePapo\" \"mensagemRecebida\" texto");
	}

}
