package batePapo.jadix.modelo;

import java.util.List;

import edugraf.jadix.fachada.GerenteDeRede;
import edugraf.jadix.interno.rede.fachadaTelis.TratadorDeEventosDeRede;
import edugraf.jadix.tiposPrimitivos.Palavra;

public class ReceptorDeMensagens {
	private final GerenteDeRede _gerente;
	private final FachadaModelo _fachadaModelo;
	
	public ReceptorDeMensagens(FachadaModelo fachada, GerenteDeRede gerente) {
		_gerente = gerente;
		_fachadaModelo = fachada;
		_gerente.instalarTratador("\"batePapo\" texto texto", new TratadorDeRecepçãoDeMensagens());
	}
	
	private class TratadorDeRecepçãoDeMensagens implements TratadorDeEventosDeRede {
		private static final int POSICAO_DO_APELIDO_NO_PACOTE = 1;
		private static final int POSICAO_DA_MENSAGEM_NO_PACOTE = 2;

		public void seDito(List<Palavra> lista) {
			_fachadaModelo.mensagemRecebida(lista.get(POSICAO_DO_APELIDO_NO_PACOTE).comoTexto(),lista.get(POSICAO_DA_MENSAGEM_NO_PACOTE).comoTexto());
		}
	}


}
