package coresDoComponente;

import edugraf.jadix.ApliqueSemPichador;
import edugraf.jadix.eventos.EventoDeGrade;
import edugraf.jadix.eventos.nomes.NomeDeEventosDeGrade;
import edugraf.jadix.fachada.ComponenteDix;
import edugraf.jadix.fachada.TratadorDixAbstrato;

public class ApliqueCoresDoComponente extends ApliqueSemPichador{
	
	private ComponenteDix valorDoVermelhoCliqueSimples = this.obterPaginaDix().criarProcuradorDeComponente("valorDoVermelhoCliqueSimples");
	private ComponenteDix valorDoVerdeCliqueSimples = this.obterPaginaDix().criarProcuradorDeComponente("valorDoVerdeCliqueSimples");
	private ComponenteDix valorDoAzulCliqueSimples = this.obterPaginaDix().criarProcuradorDeComponente("valorDoAzulCliqueSimples");
	private ComponenteDix valorDoVermelhoCliqueDuplo = this.obterPaginaDix().criarProcuradorDeComponente("valorDoVermelhoCliqueDuplo");
	private ComponenteDix valorDoVerdeCliqueDuplo = this.obterPaginaDix().criarProcuradorDeComponente("valorDoVerdeCliqueDuplo");
	private ComponenteDix valorDoAzulCliqueDuplo = this.obterPaginaDix().criarProcuradorDeComponente("valorDoAzulCliqueDuplo");
	private ComponenteDix grade =  this.obterPaginaDix().criarProcuradorDeComponente("grade");
	private TratadorDixAbstrato tratadorDeClique,tratadorDeCliqueDuplo;
	private int valorVermelhoDaCor = 0,valorVerdeDaCor = 0,valorAzulDaCor = 0;
	
	public void iniciar(){ 
		tratadorDeClique = new TratadorDeCliqueSimples();
		tratadorDeCliqueDuplo = new TratadorDeCliqueDuplo();
		grade.adicionarTratadorDeEventos(tratadorDeClique);
		grade.adicionarTratadorDeEventos(tratadorDeCliqueDuplo);
	}	
	

	public void pintarCelula(EventoDeGrade evento)
	{	
			String nomeDaCelula = evento.obterNomeDoComponente() + "_" + evento.obterLinha() + "_" + evento.obterColuna();
			ComponenteDix celulaClicada = obterPaginaDix().criarProcuradorDeComponente(nomeDaCelula);
			celulaClicada.fixarCorDePreenchimento(valorVermelhoDaCor,valorVerdeDaCor,valorAzulDaCor);
	}

	class TratadorDeCliqueSimples extends TratadorDixAbstrato{
		
		public void seDito(EventoDeGrade evento){	
			if(evento.obterNomeDoEvento().equals(NomeDeEventosDeGrade.CÉLULA_CLICADA)){
				valorVermelhoDaCor = Integer.parseInt(valorDoVermelhoCliqueSimples.obterTexto());
				valorVerdeDaCor = Integer.parseInt(valorDoVerdeCliqueSimples.obterTexto());
				valorAzulDaCor = Integer.parseInt(valorDoAzulCliqueSimples.obterTexto());
				pintarCelula(evento);
			}
		}
	}
	
	class TratadorDeCliqueDuplo extends TratadorDixAbstrato{
		
		public void seDito(EventoDeGrade evento){	
			if(evento.obterNomeDoEvento().equals(NomeDeEventosDeGrade.CÉLULA_DUPLAMENTE_CLICADA)){
				valorVermelhoDaCor = Integer.parseInt(valorDoVermelhoCliqueDuplo.obterTexto());
				valorVerdeDaCor = Integer.parseInt(valorDoVerdeCliqueDuplo.obterTexto());
				valorAzulDaCor = Integer.parseInt(valorDoAzulCliqueDuplo.obterTexto());
				pintarCelula(evento);
			}
		}
	}
	
	
}
