package ediJadix;

import static edugraf.jadix.eventos.nomes.NomesDosEventosDeMouse.MOUSE_ARRASTANDO;
import static edugraf.jadix.eventos.nomes.NomesDosEventosDeMouse.MOUSE_PRESSIONADO;

import java.awt.Point;
import java.util.List;

import javax.swing.JApplet;

import edugraf.jadix.Aplique;
import edugraf.jadix.eventos.EventoDeMouse;
import edugraf.jadix.fachada.TratadorDeEventos;
import edugraf.jadix.fachada.TratadorDixAbstrato;
import edugraf.jadix.tiposPrimitivos.Palavra;
import edugraf.pichador.TipoPichador;
import edugraf.pichador.desenho.Cor;

public class ApliqueEdiJadix extends Aplique implements TratadorDeEventos {

	private TipoPichador pichador;
	private JApplet applet;
	private EdiJadix ediJadix;
	private Cor cor;

	public void iniciar() {
		pichador = this.criarPichador();
		applet = this.obterApplet();
		ediJadix = new EdiJadix(pichador);
		
		this.adicionarTratadorDeEventos(new Tratador());
		this.obterPaginaDix().instalarTratador("FIXAR_COR_DOS_RASTROS número número número",this);
	}
	
	public void seDito(List<Palavra> evento) {
		cor = new Cor((int) obterElemento(2, evento).comoNumero(), (int) obterElemento(3, evento).comoNumero(), (int) obterElemento(4, evento).comoNumero());
		
		ediJadix.fixarCor(cor);
	}

	public class Tratador extends TratadorDixAbstrato {
		private static final int CÓDIGO_DO_BOTÃO_DIREITO_DO_MOUSE = 4;
		private static final int CÓDIGO_DO_BOTÃO_ESQUERDO_DO_MOUSE = 16;
		private Point ponto;

		public void seDito(EventoDeMouse evento) {
			if (evento.obterNomeDoEvento() == MOUSE_ARRASTANDO
					&& evento.obterModificadores() == CÓDIGO_DO_BOTÃO_ESQUERDO_DO_MOUSE) {
				ponto = gerarPontoCorrigido(evento.obterPosição());
				
				ediJadix.riscar(ponto);
			}

			if (evento.obterNomeDoEvento() == MOUSE_PRESSIONADO) {
				ponto = gerarPontoCorrigido(evento.obterPosição());
				
				ediJadix.andarSemRastrosPara(ponto);
				if (evento.obterModificadores() == CÓDIGO_DO_BOTÃO_DIREITO_DO_MOUSE) {
					ediJadix.pintarÁrea();
				}
			}
			
		}
		
		private Point gerarPontoCorrigido(Point ponto) {
			return new Point(obterX(ponto), obterY(ponto));
		}

		private int obterY(Point ponto) {
			return (int) -(ponto.getY() - applet.getHeight() / 2);
		}

		private int obterX(Point ponto) {
			return (int) (ponto.getX() - applet.getWidth() / 2);
		}
	}
	
	private Palavra obterElemento(int númeroDoElemento, List<Palavra> evento) {
		int indexDoElemento = númeroDoElemento - 1;
		return evento.get(indexDoElemento);
	}
}