package ediJadix;

import java.awt.Point;

import javax.swing.JApplet;

import edugraf.jadix.Aplique;
import edugraf.jadix.eventos.EventoDeMouse;
import edugraf.jadix.eventos.nomes.NomesDosEventosDeMouse;
import edugraf.jadix.fachada.PaginaDix;
import edugraf.jadix.fachada.TratadorDixAbstrato;
import edugraf.pichador.TipoPichador;
import edugraf.pichador.desenho.Cor;

public class ApliquePalheta extends Aplique{
	
	private static final int LADO_DOS_QUADRADOS_DAS_CORES = 20;
	private final Cor cores[] = Palheta.cores;
	private TipoPichador pichador;
	private Palheta palheta;
	private JApplet applet;
	private PaginaDix página;
	
	public void iniciar(){
		applet = this.obterApplet();
		página = this.obterPaginaDix();
		pichador = this.criarPichador();
		palheta = new Palheta(pichador);
		palheta.desenharBarraDeCores();
		this.adicionarTratadorDeEventos(new TratadorDaPalheta());
	}
	
	public class TratadorDaPalheta extends TratadorDixAbstrato{
		
		private static final int CÓDIGO_DO_BOTÃO_DIREITO_DO_MOUSE = 16;

		public void seDito(EventoDeMouse evento){
			if(evento.obterNomeDoEvento() == NomesDosEventosDeMouse.MOUSE_PRESSIONADO){
				if(evento.obterModificadores() == CÓDIGO_DO_BOTÃO_DIREITO_DO_MOUSE){
					Point ponto = gerarPontoCorrigido(evento.obterPosição());
					palheta.andarPara(ponto);
					
					Cor corSelecionada = obterCorDoPonto(evento.obterPosição());
					página.fixarParametro(corSelecionada.obterVermelho())
							.fixarParametro(corSelecionada.obterVerde())
							.fixarParametro(corSelecionada.obterAzul())
							.dizer("FIXAR_COR_DOS_RASTROS número número número");
				}
			}
		}
		
		private Cor obterCorDoPonto(Point point) {
			int códigoDaCor = (int) (point.getX() / LADO_DOS_QUADRADOS_DAS_CORES);
			return cores[códigoDaCor];
		}

		private Point gerarPontoCorrigido(Point ponto) {
			return new Point(obterX(ponto), obterY(ponto));
		}

		private int obterY(Point ponto) {
			return (int) -(ponto.getY() - applet.getHeight() / 2);
		}

		private int obterX(Point ponto) {
			return (int) (ponto.getX() - applet.getWidth() / 2);
		}
	}

}
