package ediJadix;

import java.awt.Point;

import edugraf.pichador.TipoPichador;
import edugraf.pichador.desenho.Cor;

public class Palheta {
	private static final int CANTO_ESQUEDO_DO_APLIQUE = -150;
	private static final int LADO_DOS_QUADRADOS_DAS_CORES = 20;
	private TipoPichador pichador;
	protected static final Cor cores[] =	
	{ 
		new Cor(  0,   0,   0),
		new Cor(128,   0,   0),
		new Cor(  0, 128,   0),
		new Cor(128, 128,   0),
		new Cor(  0,   0, 128),
		new Cor(128,   0, 128),
		new Cor(  0, 128, 128),
		new Cor(192, 192, 192),        
		new Cor(128, 128, 128),
		new Cor(255,   0,   0),
		new Cor(  0, 255,   0),
		new Cor(255, 255,   0),
		new Cor(  0,   0, 255),
		new Cor(255,   0, 255),
		new Cor(  0, 255, 255),
		new Cor(255, 255, 255)
	};

	public Palheta(TipoPichador pichador) {
		this.pichador = pichador;
	}
	
	public void desenharBarraDeCores() {
		pichador.andarPara(CANTO_ESQUEDO_DO_APLIQUE, 0)
				.direita(90)
				.fixarEspessura(LADO_DOS_QUADRADOS_DAS_CORES)
				.comRastros();
		for(int contarGiro = 0; contarGiro <= 15; contarGiro++){
			pichador.fixarCorDosRastros(cores[contarGiro])
					.frente(LADO_DOS_QUADRADOS_DAS_CORES);
		}
		pichador.semRastros();
	}

	public void andarPara(Point ponto) {
		pichador.andarPara((int) ponto.getX(), (int) ponto.getY());
	}

}
