package exemploComListas;

import edugraf.jadix.ApliqueSemPichador;
import edugraf.jadix.eventos.EventoSimples;
import edugraf.jadix.eventos.EventoDeSelecao;
import edugraf.jadix.eventos.nomes.NomeDeEventosSimples;
import edugraf.jadix.fachada.ComponenteDix;
import edugraf.jadix.fachada.TratadorDixAbstrato;

 public class ApliqueExemploComListas extends ApliqueSemPichador {
	
	 private ComponenteDix listaDeAssuntos = this.obterPaginaDix().criarProcuradorDeComponente("listaDeAssuntos");
	 private ComponenteDix listaAssuntoEscolhido = this.obterPaginaDix().criarProcuradorDeComponente("listaAssuntoEscolhido");
	 private ComponenteDix itemQueSeraIncluido = this.obterPaginaDix().criarProcuradorDeComponente("itemQueSeraIncluido");
	 private ComponenteDix botaoIncluirItemNaLista = this.obterPaginaDix().criarProcuradorDeComponente("botaoIncluirItemNaLista");
	 private ControleDasListas controladorDeListas;
	
	public void iniciar(){ 
		controladorDeListas = new ControleDasListas();
		TratadorDaListaDeAssuntos tratadorListaDeAssuntos = new TratadorDaListaDeAssuntos();
		TratadorBotaoIncluirNaLista tratadorBotaoIncluir = new TratadorBotaoIncluirNaLista();
		listaDeAssuntos.adicionarTratadorDeEventos(tratadorListaDeAssuntos);
		botaoIncluirItemNaLista.adicionarTratadorDeEventos(tratadorBotaoIncluir);
	}	
	
	protected void atualizarListaSelecionada(){
		listaAssuntoEscolhido.fixarLista(controladorDeListas.obterUltimaListaSelecionada());
	}
	
	class TratadorDaListaDeAssuntos extends TratadorDixAbstrato{
		public void seDito(EventoDeSelecao evento){
			controladorDeListas.selecionarLista(evento.obterNumeroDaOpcao());
			atualizarListaSelecionada();
		}
	}
	
	class TratadorBotaoIncluirNaLista extends TratadorDixAbstrato{	
		public void seDito(EventoSimples evento)
		{	
			if(evento.obterNomeDoEvento().equals(NomeDeEventosSimples.CLICADO)){
				controladorDeListas.adicionarNaListaSelecionada(itemQueSeraIncluido.obterTexto());
				atualizarListaSelecionada();
			}
		}
	}
}
