package fixarFoco;

import edugraf.jadix.ApliqueSemPichador;
import edugraf.jadix.eventos.EventoSimples;
import edugraf.jadix.eventos.nomes.NomeDeEventosSimples;
import edugraf.jadix.fachada.ComponenteDix;
import edugraf.jadix.fachada.TratadorDixAbstrato;

 public class ApliqueFixarFoco extends ApliqueSemPichador {
	
	 private ComponenteDix caixaDeTexto = this.obterPaginaDix().criarProcuradorDeComponente("caixaDeTexto");
	 private ComponenteDix botaoFixarFocoNaCaixaDeTexto =  this.obterPaginaDix().criarProcuradorDeComponente("botaoFixarFocoNaCaixaDeTexto");
	 private ComponenteDix caixaDeEscolha =  this.obterPaginaDix().criarProcuradorDeComponente("caixaDeEscolha");
	 private ComponenteDix botaoFixarFocoNaCaixaDeEscolha = this.obterPaginaDix().criarProcuradorDeComponente("botaoFixarFocoNaCaixaDeEscolha");
	 private ComponenteDix mostrador = this.obterPaginaDix().criarProcuradorDeComponente("mostrador");
	 
	 
	public void iniciar(){ 
		TratadorDoBotaoFixarFoco tratadorCaixaDeTexto = new TratadorDoBotaoFixarFoco(caixaDeTexto);
		botaoFixarFocoNaCaixaDeTexto.adicionarTratadorDeEventos(tratadorCaixaDeTexto);
		
		TratadorDoBotaoFixarFoco tratadorCaixaDeEscolha = new TratadorDoBotaoFixarFoco(caixaDeEscolha);
		botaoFixarFocoNaCaixaDeEscolha.adicionarTratadorDeEventos(tratadorCaixaDeEscolha);
	}	
	
	class TratadorDoBotaoFixarFoco extends TratadorDixAbstrato{
		
		private ComponenteDix componenteOndeFocoSeraFixado;
		 
		TratadorDoBotaoFixarFoco(ComponenteDix umComponente)
		{
			componenteOndeFocoSeraFixado = umComponente;
		}
		
		public void seDito(EventoSimples evento)
		{	
			if(evento.obterNomeDoEvento().equals(NomeDeEventosSimples.CLICADO)){
				componenteOndeFocoSeraFixado.fixarFoco();
				mostrador.fixarTexto(componenteOndeFocoSeraFixado.obterNome());
			}
		}
	}
}
