package pintandoAGrade;

import edugraf.jadix.ApliqueSemPichador;
import edugraf.jadix.eventos.EventoDeGrade;
import edugraf.jadix.fachada.ComponenteDix;
import edugraf.jadix.fachada.TratadorDixAbstrato;

public class ApliquePintandoAGrade extends ApliqueSemPichador {
	
	private ComponenteDix gradeGrande = this.obterPaginaDix().criarProcuradorDeComponente("gradeGrande");
	private ComponenteDix gradePequena = this.obterPaginaDix().criarProcuradorDeComponente("gradePequena");
	private TratadorDixAbstrato tratadorDeClique;
	private EstrategiaDeObterComandos estrategiaDeObterComandos = new EstrategiaDeObterComandos(gradeGrande,gradePequena);

	public void iniciar() {
		tratadorDeClique = new TratadorDeClique();
		gradeGrande.adicionarTratadorDeEventos(tratadorDeClique);
		gradePequena.adicionarTratadorDeEventos(tratadorDeClique);
	}

	public ComponenteDix obterCélula(EventoDeGrade evento) {
		String nomeDaCelula = evento.obterNomeDoComponente() + "_" + evento.obterLinha() + "_" + evento.obterColuna();
		ComponenteDix celulaClicada = obterPaginaDix().criarProcuradorDeComponente(nomeDaCelula);
		return celulaClicada;
	}

	class TratadorDeClique extends TratadorDixAbstrato {
		public void seDito(EventoDeGrade evento) {
			if(estrategiaDeObterComandos.contemComandoAssociado(evento)){
				estrategiaDeObterComandos.obterComando(evento).executar(obterCélula(evento));
			}
		}
	}	
}
