package pintandoAGrade;

import java.util.HashMap;
import java.util.Map;

import edugraf.jadix.eventos.EventoDeGrade;
import edugraf.jadix.eventos.nomes.NomeDeEventosDeGrade;
import edugraf.jadix.eventos.nomes.NomeDeEventosDix;
import edugraf.jadix.fachada.ComponenteDix;

public class EstrategiaDeObterComandos {
	
	private Map<AssociacaoComponenteNomeDeEvento, ComandoDePinturaDeCelulas> mapaDeComandos = new HashMap<AssociacaoComponenteNomeDeEvento, ComandoDePinturaDeCelulas>();
	
	public EstrategiaDeObterComandos(ComponenteDix gradeGrande,ComponenteDix gradePequena) {
		mapaDeComandos.put(new AssociacaoComponenteNomeDeEvento(gradeGrande, NomeDeEventosDeGrade.CÉLULA_CLICADA),new ComandoDePinturaDeCelulas(0, 0, 255));
		mapaDeComandos.put(new AssociacaoComponenteNomeDeEvento(gradePequena, NomeDeEventosDeGrade.CÉLULA_CLICADA),new ComandoDePinturaDeCelulas(255, 0, 255));
		mapaDeComandos.put(new AssociacaoComponenteNomeDeEvento(gradeGrande, NomeDeEventosDeGrade.CÉLULA_DUPLAMENTE_CLICADA),new ComandoDePinturaDeCelulas(0, 255, 0));
		mapaDeComandos.put(new AssociacaoComponenteNomeDeEvento(gradePequena, NomeDeEventosDeGrade.CÉLULA_DUPLAMENTE_CLICADA),new ComandoDePinturaDeCelulas(0, 0, 0));
	}
	
	public ComandoDePinturaDeCelulas obterComando(EventoDeGrade evento){
		ComandoDePinturaDeCelulas comando = null;
		comando = mapaDeComandos.get(obterAssociação(evento));
		return comando;
	}

	private AssociacaoComponenteNomeDeEvento obterAssociação(EventoDeGrade evento) {
		return new AssociacaoComponenteNomeDeEvento(evento.obterComponente(), evento.obterNomeDoEvento());
	}
	
	public boolean contemComandoAssociado(EventoDeGrade evento) {
		return mapaDeComandos.containsKey(obterAssociação(evento));
	}
	class AssociacaoComponenteNomeDeEvento {
		ComponenteDix componente;
		NomeDeEventosDix nomeDoEventoDeGrade;

		public AssociacaoComponenteNomeDeEvento(ComponenteDix componente,NomeDeEventosDix nomeDoEventoDeGrade) {
			this.componente = componente;
			this.nomeDoEventoDeGrade = nomeDoEventoDeGrade;
		}

		public int hashCode() {
			return 0;
		}

		public boolean equals(Object outroObjeto) {
			boolean igualdade = false;
			if (outroObjeto instanceof AssociacaoComponenteNomeDeEvento) {
				if (((AssociacaoComponenteNomeDeEvento) outroObjeto).componente.equals(this.componente) && 
				    ((AssociacaoComponenteNomeDeEvento) outroObjeto).nomeDoEventoDeGrade.equals(this.nomeDoEventoDeGrade)) {
					igualdade = true;
				}
			}
			return igualdade;
		}
	}

}
