﻿function Grade(id) {
	var g = Componente('div', id, 'grade');
	g.colunas = 0;
	g.linhas = 0;
	g.celulas = null;
	g.mouseDentro = false;
	// salva função do parent
	g.superFixarLargura = g.fixarLargura;
	g.superFixarAltura = g.fixarAltura;
	g.superFixarCorDePreenchimento = g.fixarCorDePreenchimento;
	g.superHabilitar = g.habilitar;
	g.superDesabilitar = g.desabilitar;

	g.fixarLargura = function(l) {
		g.superFixarLargura(l);
		g.reposicionarCelulas();
	}
	g.fixarAltura = function(a) {
		g.superFixarAltura(a);
		g.reposicionarCelulas();
	}
	g.fixarCorDePreenchimento = function(a) {
		g.superFixarCorDePreenchimento(a);
		g.propagadorDeFuncao("fixarCorDePreenchimento", "transparent")
	}
	g.habilitar = function() {
		g.superHabilitar();
		g.propagadorDeFuncao("habilitar");
	}
	g.desabilitar = function() {
		g.superDesabilitar();
		g.propagadorDeFuncao("desabilitar");
	}

	g.propagadorDeFuncao = function(funcao, a) {
		for (var linha = 0; linha < this.linhas; linha++) { 
			for (var coluna = 0; coluna < this.colunas; coluna++) {
				eval("this.celulas[linha][coluna]." + funcao + "(a)");
			}
		}
	}
	
	g.fixarCelulas = function(linhas, colunas) {
		g.removerCelulas();
		g.colunas = colunas;
		g.linhas = linhas;
		g.celulas = new Array();
		for (var linha = 0; linha < linhas; linha++) { 
			g.celulas[linha] = new Array();
			for (var coluna = 0; coluna < colunas; coluna++) {
				idDaCelula = id + "_" + (linha + 1) + "_" + (coluna + 1);
				var c = Celula(idDaCelula, linha + 1, coluna + 1, this);
				c.adicionar();
				g.celulas[linha][coluna] = c;
			} 
		}
		g.reposicionarCelulas();
	}
		
	g.removerCelulas = function() {
		while (g.firstChild) {
			g.removeChild(g.firstChild);
		}
		g.colunas = 0;
		g.linhas = 0;
		g.celulas = null;					
	}
	
	g.reposicionarCelulas = function() {
   		var larguraDasCelulas = Math.floor(g.obterLargura() / g.colunas);
   		var alturaDasCelulas = Math.floor(g.obterAltura() / g.linhas);
		var xAtual = 0;
		var yAtual = 0;

		for (var linha = 0; linha < g.linhas; linha++) {
			for (var coluna = 0; coluna < g.colunas; coluna++) {
				var c = g.celulas[linha][coluna];
				c.fixarEsquerda(xAtual + "");   // tranforma em string, se passar como numero o fixar transforma para null
				c.fixarTopo(yAtual + "");
				c.fixarAltura(alturaDasCelulas + "");
				c.fixarLargura(larguraDasCelulas + "");
				xAtual = xAtual + larguraDasCelulas;
			}
			xAtual = 0;
			yAtual = yAtual + alturaDasCelulas;
		}
	}
	// estimulos
	g.onmouseoverVelho = g.onmouseover;
	g.onmouseoutVelho = g.onmouseout;
	g.onmouseover = function(evento) {
		if (!g.mouseDentro) {
			g.mouseDentro = true;
			g.onmouseoverVelho();
		}
	}
	g.onmouseout = function(evento) {
		if (!evento) evento = window.event;
		try {
			var componenteEntrou = !evento.toElement ? evento.relatedTarget : evento.toElement;
			if (componenteEntrou != this && componenteEntrou.parentNode != this) {
				g.onmouseoutVelho();
				g.mouseDentro = false;
			}
		} catch(e) {
			g.onmouseoutVelho();
			g.mouseDentro = false;
		}
	}
	
	g.adicionar();
	return g;
}

function Celula(id, linha, coluna, grade) {
	var c = Componente("div", id, "célula");
	c.coluna = coluna;
	c.linha = linha;
	c.grade = grade;
	// problema de fixarAltura no IE, ele bloqueia a mudança de tamanho se não couber o texto no div
	c.style.fontSize = "1px";
	c.style.margin="0px";
	// estímulos
	c.enviarEstimulo = function(tipo) {
    	esquerda = c.obterEsquerda();
    	topo = c.obterTopo();
		var estimulo = "[ \"grade\"  \"" + c.grade.id + "\" \"" + tipo + "\" [" + c.linha + " " + c.coluna + "] [" + esquerda + " " + topo + "] ]";
		propagarEvento(estimulo, this);
	}
    c.onclick = function() {
    	c.enviarEstimulo("célulaClicada");
		return true;
	}
	c.ondblclick = function() {
    	c.enviarEstimulo("célulaDuplamenteClicada");
		return true;
	}
	c.onmouseover = function() {
		c.enviarEstimulo("cursorEntrouNaCélula");
		return true;
	}
	c.onmouseout = function() {
		c.enviarEstimulo("cursorSaiuDaCélula");
		return true;
	}
	// remove estímulos "inuteis"
	c.onchange = null;
	c.onkeydown = null;

	c.adicionar = function() { c.grade.appendChild(this) }
	return c;
}