package engrenagem;

import edugraf.jadix.Aplique;
import edugraf.pichador.TipoPichador;
import static edugraf.jadix.primitivas.Primitiva.descansar;

public class ApliqueDasEngrenagens extends Aplique {

	private static final int VELOCIDADE = 3;
	private TipoPichador engrenagemMaior;
	private TipoPichador engrenagemMenor;

	@Override
	public void iniciar() {
		criarEngrenagemMenor();
		criarEngrenagemMaior();		
		girar();
	}

	private void girar() {
		while (true) {
			engrenagemMaior.direita(1*VELOCIDADE);
			engrenagemMenor.direita(-2*VELOCIDADE);
			descansar(0.1);
		}
	}

	private void criarEngrenagemMenor() {
		engrenagemMenor = criarPichador();
		engrenagemMenor.semRastros();
		engrenagemMenor.fixarÍconeGirável("engrenagemCom8Dentes.png");
		engrenagemMenor.direita(90).frente(70);
		int ânguloDeEncaixeComAEngrenagemMaior = 360/16;
		engrenagemMenor.direita(ânguloDeEncaixeComAEngrenagemMaior);
		engrenagemMenor.tornarVisível();
	}

	private void criarEngrenagemMaior() {
		engrenagemMaior = criarPichador();
		engrenagemMaior.fixarÍconeGirável("engrenagemCom16Dentes.png");
		engrenagemMaior.tornarVisível();
	}
}
