package eventoTeclaRepetida;

import static edugraf.jadix.eventos.nomes.NomeDeEventosDeTeclado.TECLA_REPETIDA;
import edugraf.jadix.Aplique;
import edugraf.jadix.eventos.EventoDeTeclado;
import edugraf.jadix.fachada.ComponenteDix;
import edugraf.jadix.fachada.TratadorDixAbstrato;
public class ApliqueTeclaRepetida extends Aplique {
	private static final String MENSAGEM_EVENTO_TECLA_REPETIDA_GERADO = "Evento de tecla repetida gerado";
	private static final String CAMPO_QUE_GERA_EVENTOS = "campoDeEntrada";
	private static final String CAMPO_QUE_MOSTRA_EVENTOS = "campoDeEventosGerados";
	private ComponenteDix _campoQueMostraEventoTeclaRepetida;
	private ComponenteDix _campoQueGeraEventos;

	@Override
	public void iniciar() {
		_campoQueMostraEventoTeclaRepetida = obterPaginaDix().criarProcuradorDeComponente(CAMPO_QUE_MOSTRA_EVENTOS);
		_campoQueGeraEventos = obterPaginaDix().criarProcuradorDeComponente(CAMPO_QUE_GERA_EVENTOS);
		_campoQueGeraEventos.adicionarTratadorDeEventos(new TratadorDeEventoTeclaRepetida());
	}

	private class TratadorDeEventoTeclaRepetida extends TratadorDixAbstrato {

		@Override
		public void seDito(EventoDeTeclado evento) {
			if (evento.obterNomeDoEvento() == TECLA_REPETIDA)
				_campoQueMostraEventoTeclaRepetida.fixarTexto(MENSAGEM_EVENTO_TECLA_REPETIDA_GERADO);
		}

	}

}
