package mostrarCirculoNaPosicaoDoCliqueNoAplique;

import edugraf.jadix.Aplique;
import edugraf.jadix.eventos.EventoDeMouse;
import edugraf.jadix.eventos.nomes.NomesDosEventosDeMouse;
import edugraf.jadix.fachada.TratadorDixAbstrato;

public class ApliqueQueDesenhaCirculosAoSerClicado extends Aplique {

	public abstract class TratadorDeCliqueNoAplique extends TratadorDixAbstrato {
		
		@Override
		public void seDito(EventoDeMouse evento) {
			if (evento.obterNomeDoEvento().equals(NomesDosEventosDeMouse.MOUSE_PRESSIONADO))
				tratarClique(evento);
		}

		public abstract void tratarClique(EventoDeMouse evento);
		
	}

	@Override
	public void iniciar() {
		
		adicionarTratadorDeEventos(new TratadorDeCliqueNoAplique() {
		
			@Override
			public void tratarClique(EventoDeMouse evento) {
				int x = evento.obterEsquerda();
				int y = evento.obterTopo();
				
				mostrarPontoClicado(x, y);
			}
				
		});
	}

	private void mostrarPontoClicado(int x, int y) {
		final int RAIO = 5;
		desenharCírculo(RAIO, x, y);
	}

	private void desenharCírculo(final int RAIO, int xCentro, int yCentro) {
		obterApplet().getGraphics().drawOval(xCentro - RAIO, yCentro - RAIO, 2*RAIO, 2*RAIO);
	}
}
