package nomeDoEventoComoEnumeracao;

import edugraf.jadix.ApliqueSemPichador;
import edugraf.jadix.eventos.EventoSimples;
import edugraf.jadix.eventos.nomes.NomeDeEventosSimples;
import edugraf.jadix.fachada.ComponenteDix;
import edugraf.jadix.fachada.PaginaDix;
import edugraf.jadix.fachada.TratadorDixAbstrato;

public class ApliqueNomeDoEventoComoEnumeracao extends ApliqueSemPichador {

	public abstract class TratadorDeCliqueNoBotao extends TratadorDixAbstrato {
		
		@Override
		public void seDito(EventoSimples evento) {
			if (evento.obterNomeDoEvento().equals(NomeDeEventosSimples.CLICADO))
				tratarClique(evento);
		}

		protected abstract void tratarClique(EventoSimples evento);
		
	}

	@Override
	public void iniciar() {
		PaginaDix página = obterPaginaDix();
		ComponenteDix botão = página.criarProcuradorDeComponente("botãoSumir");
		
		botão.adicionarTratadorDeEventos(new TratadorDeCliqueNoBotao() {
		
			@Override
			protected void tratarClique(EventoSimples evento) {
				evento.obterComponente().tornarInvisivel();
			}
		
		});
	}
	
}
