package obterCorDoPonto;

import java.awt.Color;

import edugraf.jadix.Aplique;
import edugraf.jadix.eventos.EventoSimples;
import edugraf.jadix.eventos.nomes.NomeDeEventosSimples;
import edugraf.jadix.fachada.ComponenteDix;
import edugraf.jadix.fachada.TratadorDixAbstrato;
import edugraf.pichador.TipoPichador;
import edugraf.pichador.desenho.Cor;

public class ApliqueQueObtemCorDoPonto extends Aplique {
	private ComponenteDix botãoPichar = this.obterPaginaDix().criarProcuradorDeComponente("botaoPichar");
	private ComponenteDix botãoObterForaDaArea = this.obterPaginaDix().criarProcuradorDeComponente("botaoObterCorForaDaAreaVisivel");
	private ComponenteDix corInseridaR = this.obterPaginaDix().criarProcuradorDeComponente("corInseridaR");
	private ComponenteDix corInseridaG = this.obterPaginaDix().criarProcuradorDeComponente("corInseridaG");
	private ComponenteDix corInseridaB = this.obterPaginaDix().criarProcuradorDeComponente("corInseridaB");
	private ComponenteDix corObtidaR = this.obterPaginaDix().criarProcuradorDeComponente("corObtidaR");
	private ComponenteDix corObtidaG = this.obterPaginaDix().criarProcuradorDeComponente("corObtidaG");
	private ComponenteDix corObtidaB = this.obterPaginaDix().criarProcuradorDeComponente("corObtidaB");
	

	private TipoPichador pichador;

	public void iniciar() {
		pichador = this.criarPichador();
		botãoPichar.adicionarTratadorDeEventos(new TratadorDeBotaoPicharPressionado());
		botãoObterForaDaArea.adicionarTratadorDeEventos(new TratadorDeBotaoObterCorForaDoAplique());
	}

	class TratadorDeBotaoPicharPressionado extends TratadorDixAbstrato {

		public void seDito(EventoSimples evento) {
			if (evento.obterNomeDoEvento().equals(NomeDeEventosSimples.CLICADO)) {
				pichador.fixarCorDosRastros(new Cor(
						Integer.valueOf(corInseridaR.obterTexto()), 
						Integer.valueOf(corInseridaG.obterTexto()), 
						Integer.valueOf(corInseridaB.obterTexto())));
				
				pichador.frente(2);
				
				Cor corObtida = pichador.obterCorDoPonto();
				
				corObtidaR.fixarTexto(String.valueOf(corObtida.obterVermelho()));
				corObtidaG.fixarTexto(String.valueOf(corObtida.obterVerde()));
				corObtidaB.fixarTexto(String.valueOf(corObtida.obterAzul()));
			}

		}
	}
	
	class TratadorDeBotaoObterCorForaDoAplique extends TratadorDixAbstrato {

		public void seDito(EventoSimples evento) {
			if (evento.obterNomeDoEvento().equals(NomeDeEventosSimples.CLICADO)) {
				pichador.semRastros();
				pichador.frente(100000);
				Cor corObtida = pichador.obterCorDoPonto();
				
				corObtidaR.fixarTexto(String.valueOf(corObtida.obterVermelho()));
				corObtidaG.fixarTexto(String.valueOf(corObtida.obterVerde()));
				corObtidaB.fixarTexto(String.valueOf(corObtida.obterAzul()));
				pichador.frente(-100000);
				pichador.comRastros();
			}

		}
	}
}
