package tocarSomNaoBloqueiaExecucaoDoPrograma;

public class ControleDoTamanhoDoComponente {
	
	private ComponenteDeAlturaVariavel componente;
	private int acrescimo = 10;
	private double tempoDeDescanso;
	
	ControleDoTamanhoDoComponente(ComponenteDeAlturaVariavel umComponente){
		componente = umComponente;
	}
	
	public void aumentarImagemAte(int tamanhoMaximo)
	{
		while(componente.obterAltura() < tamanhoMaximo){
			componente.aumentarAltura(acrescimo);
			this.dormir();
		}	
	}
	
	public void diminuirImagemAte(int tamanhoMinimo)
	{
		while(componente.obterAltura() > tamanhoMinimo){
			componente.diminuirAltura(acrescimo);
			this.dormir();
		}	
	}
	
	public void fixarTempoDeDescanso(double tempoEmSegundos)
	{
		tempoDeDescanso = tempoEmSegundos;
	}
	
	public void fixarAcrescimo(int valorDoAcrescimo)
	{
		acrescimo = valorDoAcrescimo;
	}
	
	private void dormir()
	{
		try {
			Thread.sleep((long) (tempoDeDescanso * 1000));
		} catch (InterruptedException e) {
			e.printStackTrace();
		}
	}
}
