package componentes.abstratos.gedix;

import infraestrutura.AtributosDosComponentesGedix;
import infraestrutura.PosicoesDeLegenda;
import infraestrutura.TiposDeComponentesGedix;
import java.io.Serializable;
import java.util.Map;


public interface TipoComponenteGedix extends Serializable {

	public void desabilitar();

	public boolean estHabilitado();

	public boolean estVisvel();

	public void fixarAltura(int novaAltura);

	public void fixarEsquerda(int novaEsquerda);

	public void fixarLargura(int novaLargura);

	public void fixarLegenda(String novaLegenda);

	public void fixarPosioDeLegenda(PosicoesDeLegenda novaPosio);

	public void fixarProfundidade(int novaProfundidade);

	public void fixarTopo(int novoTopo);

	public String gerarXML();

	public void habilitar();

	public int obterAltura();

	public int obterEsquerda();

	public int obterLargura();

	public String obterLegenda();

	public Map<AtributosDosComponentesGedix, String> obterMapeamentoAtributoValor();

	public String obterNome();

	public PosicoesDeLegenda obterPosioDeLegenda();

	public int obterProfundidade();

	public TiposDeComponentesGedix obterTipo();

	public int obterTopo();

	public void tornarInvisvel();

	public void tornarVisvel();
}
