package componentes.abstratos.opcao;

import java.util.Collection;
import java.util.HashMap;
import java.util.Map;
import componentes.TipoOpcao;
import componentes.abstratos.gedix.ComponenteGedix;


public class ComponenteComOpcao extends ComponenteGedix implements TipoComponenteComOpcao {

	private static final long serialVersionUID = 1L;
	protected Map<String, TipoOpcao> opes;

	public ComponenteComOpcao() {
		opes = new HashMap<String, TipoOpcao>();
	}

	public void adicionarOpo(TipoOpcao opo) {
		opes.put(opo.obterNome(), opo);
	}

	protected String gerarParteBsicaDoXML() {

		String XMLDasOpes = "";

		for (final TipoOpcao opo : opes.values())
			XMLDasOpes = XMLDasOpes + "\n<opo nome=\"" + opo.obterNome() + "\">"
					+ opo.obterTexto() + "</opo>";
		return super.gerarParteBsicaDoXML() + ">" + XMLDasOpes + "\n";

	}

	public Collection<TipoOpcao> obterOpes() {
		return opes.values();
	}

	public void removerOpo(String nome) {
		opes.remove(nome);
	}

}
