package componentes.comtexto.etiqueta;

import static infraestrutura.AtributosDosComponentesGedix.nome;
import static infraestrutura.AtributosDosComponentesGedix.tipoDoComponente;
import static infraestrutura.AtributosDosComponentesGedix.uri;
import infraestrutura.TiposDeComponentesGedix;
import componentes.abstratos.texto.ComponenteComTexto;


public class Etiqueta extends ComponenteComTexto implements TipoEtiqueta {

	private static final long serialVersionUID = 1L;
	private static int nmeroDeInstncias;

	public Etiqueta() {
		super();
		nmeroDeInstncias++;
		mapeamentoAtributoValor.put(tipoDoComponente, TiposDeComponentesGedix.etiqueta
				.toString());
		mapeamentoAtributoValor.put(nome, obterTipo().toString() + "_"
				+ nmeroDeInstncias);
		fixarURI(null);

	}

	public void fixarURI(String novaURI) {
		mapeamentoAtributoValor.put(uri, novaURI);
	}

	protected String gerarParteBsicaDoXML() {
		String xmlDaURI = "";

		if (obterURI() != null)
			xmlDaURI = " url=\"" + obterURI() + "\"";
		return super.gerarParteBsicaDoXML() + xmlDaURI + ">" + obterTexto();
	}

	public String obterURI() {
		return mapeamentoAtributoValor.get(uri);
	}

}
