package componentes.grade;

import static infraestrutura.AtributosDosComponentesGedix.colunas;
import static infraestrutura.AtributosDosComponentesGedix.linhas;
import static infraestrutura.AtributosDosComponentesGedix.nome;
import static infraestrutura.AtributosDosComponentesGedix.tipoDoComponente;
import infraestrutura.AtributosDosComponentesGedix;
import infraestrutura.TiposDeComponentesGedix;
import java.util.HashMap;
import java.util.Map;
import componentes.abstratos.gedix.ComponenteGedix;


public class Grade extends ComponenteGedix implements TipoGrade {

	private static final long serialVersionUID = 1L;
	private static int nmeroDeInstncias;

	public Grade() {
		nmeroDeInstncias++;
		mapeamentoAtributoValor.put(tipoDoComponente, TiposDeComponentesGedix.grade
				.toString());
		mapeamentoAtributoValor.put(nome, obterTipo().toString() + "_"
				+ nmeroDeInstncias);
		fixarColunas(3);
		fixarLinhas(3);
	}

	public void fixarColunas(int nmeroDeColunas) {
		assert nmeroDeColunas > 0;
		mapeamentoAtributoValor.put(colunas, String.valueOf(nmeroDeColunas));
	}

	public void fixarLinhas(int nmeroDeLinhas) {
		assert nmeroDeLinhas > 0;
		mapeamentoAtributoValor.put(linhas, String.valueOf(nmeroDeLinhas));
	}

	protected String gerarParteBsicaDoXML() {
		return super.gerarParteBsicaDoXML() + " colunas=\"" + obterColunas()
				+ "\" linhas=\"" + obterLinhas() + "\">";
	}

	public int obterColunas() {
		return Integer.parseInt(mapeamentoAtributoValor.get(colunas));
	}

	public int obterLinhas() {
		return Integer.parseInt(mapeamentoAtributoValor.get(linhas));
	}

	public Map<AtributosDosComponentesGedix, String> obterMapeamentoAtributoValor() {
		final Map<AtributosDosComponentesGedix, String> mapaARetornar = new HashMap<AtributosDosComponentesGedix, String>();
		mapaARetornar.putAll(mapeamentoAtributoValor);

		return mapaARetornar;
	}
}
