package componentes.imagem;

import static infraestrutura.AtributosDosComponentesGedix.nome;
import static infraestrutura.AtributosDosComponentesGedix.tipoDoComponente;
import static infraestrutura.AtributosDosComponentesGedix.uri;
import infraestrutura.AtributosDosComponentesGedix;
import infraestrutura.TiposDeComponentesGedix;
import java.util.HashMap;
import java.util.Map;
import componentes.abstratos.gedix.ComponenteGedix;


public class Imagem extends ComponenteGedix implements TipoImagem {

	private static final long serialVersionUID = 1L;
	private static int nmeroDeInstncias;

	public Imagem() {
		super();
		nmeroDeInstncias++;
		mapeamentoAtributoValor.put(tipoDoComponente, TiposDeComponentesGedix.imagem
				.toString());
		mapeamentoAtributoValor.put(nome, obterTipo().toString() + "_"
				+ nmeroDeInstncias);
		fixarURI(null);
	}

	public void fixarURI(String novaURI) {
		mapeamentoAtributoValor.put(uri, novaURI);
	}

	protected String gerarParteBsicaDoXML() {
		String xmlDaURI = "";

		if (obterURI() != null)
			xmlDaURI = " uri=\"" + obterURI() + "\"";
		return super.gerarParteBsicaDoXML() + xmlDaURI + ">";
	}

	public Map<AtributosDosComponentesGedix, String> obterMapeamentoAtributoValor() {
		final Map<AtributosDosComponentesGedix, String> mapaARetornar = new HashMap<AtributosDosComponentesGedix, String>();
		mapaARetornar.putAll(mapeamentoAtributoValor);

		return mapaARetornar;
	}

	public String obterURI() {
		return mapeamentoAtributoValor.get(uri);
	}

}
