package controle.janelaDeEdicao;

import controle.janelaDeEdicao.tratadoresDeRede.TratadorDeMostrarCampos;
import controle.janelaDeEdicao.tratadoresDeRede.TratadorDeOcultarCampos;
import controle.janelaDeEdicao.tratadoresDeRede.TratadorDePreencherCampos;
import controle.janelaDeEdicao.tratadoresDix.TratadorDePedirAtualizacao;
import edugraf.jadix.ApliqueSemPichador;
import edugraf.jadix.fachada.GerenteDeRede;
import edugraf.jadix.fachada.PaginaDix;


public class ControladorDaEdicao extends ApliqueSemPichador implements
		TipoControladorDaEdicao {

	private PaginaDix pgina;
	private TipoJanelaDeEdicao janelaEdio;
	private GerenteDeRede gerenteDeRede;

	public void enviarPedidoDeAtualizao(String campoASerAtualizado, String valorDoCampo) {
		gerenteDeRede.fixarParametro(campoASerAtualizado).fixarParametro(valorDoCampo)
				.dizer("\"atualizarComponenteSelecionado\" texto texto");
	}

	@Override
	public void iniciar() {
		pgina = obterPaginaDix();
		gerenteDeRede = obterGerenteDeRede();
		janelaEdio = new JanelaDeEdicao(pgina);

		instalarTratadores();
	}

	private void instalarTratadores() {
		janelaEdio.instalarTratadorNosCampos(new TratadorDePedirAtualizacao(this));

		gerenteDeRede
				.instalarTratador("texto", new TratadorDeMostrarCampos(janelaEdio));

		gerenteDeRede.instalarTratador("\"ocultarCamposExtras\"",
				new TratadorDeOcultarCampos(janelaEdio));

		gerenteDeRede.instalarTratador("\"preencher\" texto texto",
				new TratadorDePreencherCampos(this));
	}

	public void preencherCampo(String atributo, String valor) {
		janelaEdio.obterCampoComNome(atributo).fixarTexto(valor);
	}
}