package controle.novaPagina.tratadoresDeRede;

import infraestrutura.AtributosDosComponentesGedix;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import controle.novaPagina.TipoControladorDaNovaPagina;
import edugraf.jadix.interno.rede.fachadaTelis.TratadorDeEventosDeRede;
import edugraf.jadix.tiposPrimitivos.Palavra;


public class TratadorDeCriarComponenteDix implements TratadorDeEventosDeRede {

	private final TipoControladorDaNovaPagina controlador;

	public TratadorDeCriarComponenteDix(TipoControladorDaNovaPagina controlador) {
		this.controlador = controlador;
	}

	public void seDito(List<Palavra> estmulo) {
		final List<Palavra> listaDePares = estmulo.get(1).comoLista();
		final Map<AtributosDosComponentesGedix, String> mapaAtributoValor = new HashMap<AtributosDosComponentesGedix, String>();

		for (final Palavra palavra : listaDePares) {
			final List<Palavra> par = palavra.comoLista();
			final AtributosDosComponentesGedix atributo = AtributosDosComponentesGedix
					.valueOf(par.get(0).comoTexto());
			final String valor = par.get(1).comoTexto();

			mapaAtributoValor.put(atributo, valor);
		}

		controlador.gerarComponenteDix(mapaAtributoValor);

	}

}
