package fachada;

import infraestrutura.TiposDeComponentesGedix;
import infraestrutura.comandos.TipoComandoDeAtualizacao;
import java.util.Collection;
import componentes.abstratos.gedix.TipoComponenteGedix;


public interface TipoFachadaDoGedix {

	public void abrirPgina(String endereo);

	public void atualizar(TipoComandoDeAtualizacao comando);

	public TipoComponenteGedix criarComponenteSelecionado(int esquerda, int topo);

	public TipoComponenteGedix criarComponenteSelecionado(int esquerda, int topo,
			int altura, int largura);

	public void gerarXML(String endereo);

	public TipoComponenteGedix obterComponente(String nomeDoComponente);

	public Collection<TipoComponenteGedix> obterComponentes();

	public void removerComponente(TipoComponenteGedix componente);

	public void salvarPgina(String endereo);

	public void trocarTipoDeCriao(TiposDeComponentesGedix novoTipo);

}
