package infraestrutura.comandos;

import componentes.abstratos.gedix.TipoComponenteGedix;


public class ComandoDeAtualizarVisibilidade implements TipoComandoDeAtualizacao {

	private final boolean visibilidade;
	private final TipoComponenteGedix componenteAOperar;

	public ComandoDeAtualizarVisibilidade(TipoComponenteGedix c, boolean visibilidade) {
		componenteAOperar = c;
		this.visibilidade = visibilidade;
	}

	public void executar() {
		if (visibilidade == true)
			componenteAOperar.tornarVisvel();
		else
			componenteAOperar.tornarInvisvel();
	}

}
