package infraestrutura.geometria;

public class Posicao implements TipoPosicao {

	public static TipoPosicao mnima(TipoPosicao posicao1, TipoPosicao posicao2) {
		final int esquerdaMnima = Math.min(posicao1.obterEsquerda(), posicao2
				.obterEsquerda());
		final int topoMnimo = Math.min(posicao1.obterTopo(), posicao2.obterTopo());
		return new Posicao(esquerdaMnima, topoMnimo);
	}

	private final int esquerda;
	private final int topo;

	public Posicao(int esquerda, int topo) {
		this.esquerda = esquerda;
		this.topo = topo;
	}

	public boolean equals(Object outra) {
		if (outra instanceof TipoPosicao) {
			final TipoPosicao outraPosicao = (TipoPosicao) outra;
			return obterEsquerda() == outraPosicao.obterEsquerda()
					&& obterTopo() == outraPosicao.obterTopo();
		}
		return false;
	}

	public int obterEsquerda() {
		return esquerda;
	}

	public int obterTopo() {
		return topo;
	}

	public String toString() {
		return "(" + String.valueOf(esquerda) + "," + String.valueOf(topo) + ")";
	}

}
