package infraestrutura.serializacao;

import infraestrutura.excecoes.ExcecaoDeArquivo;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectInput;
import java.io.ObjectInputStream;
import java.io.ObjectOutput;
import java.io.ObjectOutputStream;
import pagina.TipoPaginaGedix;


public class SerializadorGedix implements TipoSerializadorGedix {

	public TipoPaginaGedix recuperarPgina(String caminhoDoArquivo) {

		try {
			final FileInputStream canalEntradaArq = new FileInputStream(new File(
					caminhoDoArquivo));
			final ObjectInput canalEntradaObj = new ObjectInputStream(canalEntradaArq);
			return (TipoPaginaGedix) canalEntradaObj.readObject();

		} catch (final FileNotFoundException e) {
			throw new ExcecaoDeArquivo();
		} catch (final IOException e) {
			throw new ExcecaoDeArquivo();
		} catch (final ClassNotFoundException e) {
			throw new ExcecaoDeArquivo();
		}
	}

	public void salvarPginaEmArquivo(TipoPaginaGedix pgina, String caminhoDoArquivo) {

		try {
			final FileOutputStream canalSaidaArq = new FileOutputStream(new File(
					caminhoDoArquivo));
			final ObjectOutput canalSaidaObj = new ObjectOutputStream(canalSaidaArq);
			canalSaidaObj.writeObject(pgina);
		} catch (final FileNotFoundException e) {
			throw new ExcecaoDeArquivo();
		} catch (final IOException e) {
			throw new ExcecaoDeArquivo();
		}
	}

}
