package proxies;

import infraestrutura.excecoes.DimensoesDeGradeInvalidas;
import proxies.abstratos.ProxyDeComponenteGedix;
import componentes.grade.TipoGrade;


public class ProxyDeGrade extends ProxyDeComponenteGedix implements TipoGrade {

	private static final long serialVersionUID = 1L;
	TipoGrade grade;

	public ProxyDeGrade(TipoGrade grade) {
		super(grade);
		this.grade = grade;
	}

	public void fixarColunas(int nmeroDeColunas) {
		if (nmeroDeColunas <= 0)
			throw new DimensoesDeGradeInvalidas();
		grade.fixarColunas(nmeroDeColunas);

	}

	public void fixarLinhas(int nmeroDeLinhas) {
		if (nmeroDeLinhas <= 0)
			throw new DimensoesDeGradeInvalidas();
		grade.fixarLinhas(nmeroDeLinhas);

	}

	public int obterColunas() {
		return grade.obterColunas();
	}

	public int obterLinhas() {
		return grade.obterLinhas();
	}

}
