package testes.componentes.abstratos;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertTrue;
import infraestrutura.AtributosDosComponentesGedix;
import org.junit.Test;
import componentes.abstratos.gedix.TipoComponenteGedix;
import componentes.abstratos.texto.TipoComponenteComTexto;


public abstract class TestesDeComponenteComTexto extends TestesDeComponentesGedix {

	protected abstract TipoComponenteComTexto componenteComTexto();

	protected TipoComponenteGedix componenteGedix() {
		return componenteComTexto();
	}

	@Test
	public void seFixarOTextoDaComponenteComTextoEleSeAltera() {
		final String textoFixado = "umTextoFixadoQualquer";
		componenteComTexto().fixarTexto(textoFixado);
		assertEquals(textoFixado, componenteComTexto().obterTexto());
	}

	@Test
	public void umComponenteComTextoComeaSemTexto() {
		assertEquals("", componenteComTexto().obterTexto());
	}

	@Test
	public void umComponenteComTextoDefinidoContmSeuTextoNoToString() {
		final String repr = componenteComTexto().toString();

		assertTrue(repr.contains("texto=" + componenteComTexto().obterTexto()));
	}

	@Test
	public void umComponenteComTextoTemSeuMapeamentoCoerenteComSeuEstado() {
		final String texto = componenteComTexto().obterTexto();

		final String textoDoMapa = componenteComTexto().obterMapeamentoAtributoValor()
				.get(AtributosDosComponentesGedix.texto);

		assertEquals(texto, textoDoMapa);
	}

}
