package testes.componentes.comtexto;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertFalse;
import static org.junit.Assert.assertTrue;
import infraestrutura.TiposDeComponentesGedix;
import org.junit.Before;
import org.junit.Test;
import testes.componentes.abstratos.TestesDeComponenteComTexto;
import componentes.abstratos.texto.TipoComponenteComTexto;
import componentes.comtexto.etiqueta.Etiqueta;
import componentes.comtexto.etiqueta.TipoEtiqueta;


public class TestesDeEtiqueta extends TestesDeComponenteComTexto {

	private TipoEtiqueta etiqueta;

	@Test
	public void aoFixarSeAURIdeUmaEtiquetaElaMuda() {
		etiqueta.fixarURI("imagens/nada.jpg");
		assertEquals("imagens/nada.jpg", etiqueta.obterURI());
	}

	protected TipoComponenteComTexto componenteComTexto() {
		return etiqueta;
	}

	@Test
	public void oTipoDeUmaEtiquetaOElementoEnumEtiqueta() {
		assertEquals(TiposDeComponentesGedix.etiqueta, etiqueta.obterTipo());
	}

	@Test
	public void oXMLDaEtiquetaContmURISeAEtiquetaTemURI() {
		etiqueta.fixarURI("abc/xxx.exe");

		final String textoXMLComURI = etiqueta.gerarXML();
		assertTrue(textoXMLComURI.contains("url=\"abc/xxx.exe\""));
	}

	@Test
	public void oXMLDaEtiquetaNoContmURISeAEtiquetaNoTemURI() {
		final String textoXMLSemURI = etiqueta.gerarXML();

		assertFalse(textoXMLSemURI.contains("uri=\""));
	}

	@Before
	public void prepararTestes() {
		etiqueta = new Etiqueta();
	}

	@Test
	public void umaEtiquetaContmSuaURINoToString() {
		final String repr = etiqueta.toString();

		assertTrue(repr.contains("uri=" + etiqueta.obterURI()));
	}

	@Test
	public void umaEtiquetaTemUmaURIInicialNula() {
		assertEquals(null, etiqueta.obterURI());
	}

}
