package testes.infraestrutura;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertFalse;
import infraestrutura.geometria.Posicao;
import infraestrutura.geometria.TipoPosicao;
import org.junit.Before;
import org.junit.Test;


public class TestesDePosicao {

	private TipoPosicao posicao;

	@Test
	public void aMnimaEntreDuasPosiesUmaPosioFormadaPeloMnimoDasCoordenadas() {
		final TipoPosicao posicao2 = new Posicao(200, 250);
		final int esquerdaMnima = Math.min(posicao.obterEsquerda(), posicao2
				.obterEsquerda());
		final int topoMnimo = Math.min(posicao.obterTopo(), posicao2.obterTopo());
		final TipoPosicao mnima = new Posicao(esquerdaMnima, topoMnimo);

		assertEquals(mnima, Posicao.mnima(posicao, posicao2));
	}

	@Test
	public void duasPosiesSoIguaisSeESomenteSeSuasCoordenadasSoIguais() {
		final TipoPosicao posicaoIgual = new Posicao(132, 325);
		final TipoPosicao posicaoDiferente = new Posicao(131, 325);

		assertEquals(posicao, posicaoIgual);
		assertFalse(posicaoDiferente.equals(posicao));
	}

	@Test
	public void podeSeObterACoordenadaHorizontalDeUmaPosio() {
		assertEquals(132, posicao.obterEsquerda());
	}

	@Test
	public void podeSeObterACoordenadaVerticalDeUmaPosio() {
		assertEquals(325, posicao.obterTopo());
	}

	@Before
	public void prepararTestes() {
		posicao = new Posicao(132, 325);
	}

	@Test
	public void umaPosicaoRepresentadaComoUmParOrdenadoDeDoisValoresInteiros() {
		assertEquals("(132,325)", posicao.toString());
	}

}
