package testes.infraestrutura;

import static org.junit.Assert.assertEquals;
import infraestrutura.geometria.Posicao;
import infraestrutura.geometria.Retangulo;
import infraestrutura.geometria.TipoPosicao;
import infraestrutura.geometria.TipoRetangulo;
import org.junit.Before;
import org.junit.Test;


public class TestesDeRetangulo {

	private TipoRetangulo retangulo;

	@Test
	public void aPosioDeUmRetnguloAPosioDeSeuVrticeEsquerdoSuperior() {
		final TipoPosicao esqSup = new Posicao(13, 23);

		assertEquals(esqSup, retangulo.obterPosio());
	}

	@Test
	public void podeSeObterAAlturaDeUmRetngulo() {
		assertEquals(47, retangulo.obterAltura());
	}

	@Test
	public void podeSeObterALarguraDeUmRetngulo() {
		assertEquals(43, retangulo.obterLargura());
	}

	@Before
	public void prepararTestes() {
		retangulo = new Retangulo(new Posicao(56, 23), new Posicao(13, 70));
	}

}
