package testes.proxies;

import static org.junit.Assert.assertEquals;
import org.junit.Before;
import org.junit.Test;
import proxies.ProxyDeImagem;
import testes.proxies.abstratos.TestesDeProxyDeComponenteGedix;
import componentes.abstratos.gedix.TipoComponenteGedix;
import componentes.imagem.Imagem;
import componentes.imagem.TipoImagem;


public class TestesDeProxyDeImagem extends TestesDeProxyDeComponenteGedix {

	private TipoImagem imagem;
	private TipoImagem proxyDeImagem;

	protected TipoComponenteGedix componente() {
		return imagem;
	}

	@Before
	public void prepararTestes() {
		imagem = new Imagem();
		proxyDeImagem = new ProxyDeImagem(imagem);
		proxy = proxyDeImagem;

	}

	@Test
	public void seMandarOProxyAtualizarAURIEleOFaz() {
		imagem.fixarURI("abc");

		proxyDeImagem.fixarURI("def");
		assertEquals("def", imagem.obterURI());
	}

}
