package testes.proxies.abstratos;

import static org.junit.Assert.assertFalse;
import static org.junit.Assert.assertTrue;
import org.junit.Test;
import componentes.Opcao;
import componentes.TipoOpcao;
import componentes.abstratos.gedix.TipoComponenteGedix;
import componentes.abstratos.opcao.TipoComponenteComOpcao;


public abstract class TestesDeProxyDeComponenteComOpcao extends
		TestesDeProxyDeComponenteGedix {

	protected TipoComponenteComOpcao proxyComOpo;

	protected TipoComponenteGedix componente() {
		return componenteComOpo();
	}

	protected abstract TipoComponenteComOpcao componenteComOpo();

	@Test
	public void seMandarOAtualizadorAdicionarUmaOpoEleOFaz() {
		final TipoOpcao novaOpo = new Opcao("nomeDaOpo");

		proxyComOpo.adicionarOpo(novaOpo);
		assertTrue(componenteComOpo().obterOpes().contains(novaOpo));
	}

	@Test
	public void seMandarOAtualizadorRemoverUmaOpoEleOFaz() {
		final TipoOpcao novaOpo = new Opcao("nomeDaOpo");
		componenteComOpo().adicionarOpo(novaOpo);

		proxyComOpo.removerOpo(novaOpo.obterNome());
		assertFalse(componenteComOpo().obterOpes().contains(novaOpo));
	}
}
