package testes.proxies.comtexto;

import static org.junit.Assert.assertEquals;
import org.junit.Before;
import org.junit.Test;
import proxies.comtexto.ProxyDeEtiqueta;
import testes.proxies.abstratos.TestesDeProxyDeComponenteComTexto;
import componentes.abstratos.texto.TipoComponenteComTexto;
import componentes.comtexto.etiqueta.Etiqueta;
import componentes.comtexto.etiqueta.TipoEtiqueta;


public class TestesDeProxyDeEtiqueta extends TestesDeProxyDeComponenteComTexto {

	private TipoEtiqueta etiqueta;
	private TipoEtiqueta proxyDeEtiqueta;

	protected TipoComponenteComTexto componenteComTexto() {
		return etiqueta;
	}

	@Before
	public void prepararTestes() {
		etiqueta = new Etiqueta();
		proxyDeEtiqueta = new ProxyDeEtiqueta(etiqueta);
		proxyDeTexto = proxyDeEtiqueta;
		proxy = proxyDeTexto;
	}

	@Test
	public void seMandarOProxyAtualizarAURIEleOFaz() {
		etiqueta.fixarURI("abc");

		proxyDeEtiqueta.fixarURI("def");
		assertEquals("def", etiqueta.obterURI());
	}

}
